package com.tidspr.tsr;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

import javax.jdo.PersistenceManager;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.tidspr.tsr.factory.PMF;
import com.tidspr.tsr.factory.URCF;
import com.tidspr.tsr.security.Authority;
import com.tidspr.tsr.url.URLHandler;
import com.tidspr.tsr.url.URLHandler.PC;

public class Atms extends HttpServlet
{
    @Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
        if(!URLHandler.INSTANCE.handle(req, res, PC.Attachment)){
        	return;
        }
        atms(res, req, new File(req.getPathInfo()).getName());
    }

    @SuppressWarnings("unchecked")
    private void atms(final HttpServletResponse res,final HttpServletRequest req, final String s)
    {
    	HttpSession session = req.getSession(true);
        String id = (String)session.getAttribute("id");
    	Authority auth = (id!=null&&!id.isEmpty()) ? Authority.authorized:Authority.notauthorized;
    	String enable = (auth.isAuthorized())?"":"disabled='true'";
    	
        final PersistenceManager pm = PMF.get().getPersistenceManager();
        final String query = "select from " + com.tidspr.tsr.entity.File.class.getName() + " where wiki=='" + s.replace("'", "\\'") + "'";
        final List<com.tidspr.tsr.entity.File> list = (List<com.tidspr.tsr.entity.File>) pm.newQuery(query).execute();
        try
        {
            res.setContentType("text/html");
            res.setCharacterEncoding("UTF-8");
            final PrintWriter out = res.getWriter();
            out.write("<table>");
            for (final com.tidspr.tsr.entity.File f : list)
            {
            	final String urlpath = URCF.encode(f.wiki()) + "/" + URCF.encode(f.name());
                final String purl = "/file/" + urlpath;
                final String preview = (f.type().startsWith("image")) ? "<img src=\"" + purl + "\" width='200px' height='200px' />" : "";
                out.write("<tr><th><ul>" +
                		"<li><a href=\"" + purl + "\" style='display:block;'>" + f.name() + "</a></li>" +
                		"<li>/file/"+f.wiki()+"/"+f.name() + "</li>" + 
                		"<li>" + f.type() + "</li>" +
                		"<li>" + Integer.toString(f.blob().getBytes().length) + "Bytes</li></ul>" + 
                		"</th><td>" + preview + "</td><td><input type='button' value='Delete' onClick=\"deleteconfirm('"+urlpath+"')\" "+enable+" /></td></tr>");
            }
            out.write("</table>");
        }
        catch (final IOException e)
        {
            e.printStackTrace();
        }
    }
}
