package com.tidspr.tsr;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;

import javax.jdo.JDOObjectNotFoundException;
import javax.jdo.PersistenceManager;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.tidspr.tsr.entity.Diff;
import com.tidspr.tsr.factory.PMF;
import com.tidspr.tsr.factory.URCF;
import com.tidspr.tsr.io.DiffIO;
import com.tidspr.tsr.response.AbnormalPrinter;
import com.tidspr.tsr.response.AbnormalPrinter.ResCode;
import com.tidspr.tsr.url.URLHandler;
import com.tidspr.tsr.url.URLHandler.PC;

public class DiffGet extends HttpServlet
{
    @Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
    	 if(!URLHandler.INSTANCE.handle(req, res, PC.Diff)){
         	return;
         }
         diff(res, req, new File(req.getPathInfo()).getName());
    }

    private void diff(final HttpServletResponse res, final HttpServletRequest req, final String s)
    {
    	Diff _or = DiffIO.readDiff(s);
        if (_or == null)
        {
        	AbnormalPrinter.Singleton.print(res,req,ResCode.NotFound);
            return;
        }
        try
        {
            res.setContentType("text/html");
            res.setCharacterEncoding("UTF-8");
            final PrintWriter out = res.getWriter();
            out.write(_or.html());
        }
        catch (final IOException e)
        {
            e.printStackTrace();
        }
    }
}
