package com.tidspr.tsr;

import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.tidspr.tsr.entity.File;
import com.tidspr.tsr.factory.PMF;
import com.tidspr.tsr.response.AbnormalPrinter;
import com.tidspr.tsr.security.Authority;

import javax.jdo.JDOObjectNotFoundException;
import javax.jdo.PersistenceManager;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

public class FileDelete extends HttpServlet {

	private static final long serialVersionUID = 1L;

	public void doGet(HttpServletRequest req, HttpServletResponse res) {
    	HttpSession session = req.getSession(true);
        String id = (String)session.getAttribute("id");
    	Authority auth = (id!=null&&!id.isEmpty()) ? Authority.authorized:Authority.notauthorized;
    	if(!auth.isAuthorized()){
    		AbnormalPrinter.Singleton.print(res, req, AbnormalPrinter.ResCode.Unauthorized);
    		return;
    	}
		String file = req.getParameter("file");
		if ((file == null) || (file.isEmpty())) return;
		PersistenceManager pm = PMF.get().getPersistenceManager();
		Key k = KeyFactory.createKey(File.class.getSimpleName(), file);
		try {
			File fi = (File) pm.getObjectById(File.class, k);
			pm.deletePersistent(fi);
		} catch (JDOObjectNotFoundException localJDOObjectNotFoundException) {
		} finally {
			pm.close();
		}
	}
}