package com.tidspr.tsr;

import java.io.File;
import java.io.IOException;
import java.io.OutputStream;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.tidspr.tsr.io.FileIO;
import com.tidspr.tsr.response.AbnormalPrinter;
import com.tidspr.tsr.response.AbnormalPrinter.ResCode;
import com.tidspr.tsr.url.URLHandler;
import com.tidspr.tsr.url.URLHandler.PC;

public class FileGet extends HttpServlet
{
	private static final long serialVersionUID = 1L;

	@Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
    	if(!URLHandler.INSTANCE.handle(req, res, PC.File)){
         	return;
        }
        final File tmpf = new File(req.getPathInfo());
        ResponseFile(tmpf.getParentFile().getName() + "/" + tmpf.getName(), res , req);
    }

    private void ResponseFile(final String fname, final HttpServletResponse res, final HttpServletRequest req)
    {
    	com.tidspr.tsr.entity.File fi = FileIO.readFile(fname);

        if (fi == null)
        {
            AbnormalPrinter.Singleton.print(res,req,ResCode.NotFound);
            return;
        }
        try{
            final OutputStream out = res.getOutputStream();
            res.setContentType(fi.type());
            out.write(fi.blob().getBytes());
            out.flush();
        }
        catch (final IOException e)
        {
            e.printStackTrace();
        }
    }

}
