package com.tidspr.tsr;

import java.io.IOException;
import java.util.Date;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;


import org.apache.commons.io.IOUtils;

import com.google.appengine.api.datastore.Blob;
import com.oreilly.servlet.multipart.FilePart;
import com.oreilly.servlet.multipart.MultipartParser;
import com.oreilly.servlet.multipart.ParamPart;
import com.oreilly.servlet.multipart.Part;
import com.tidspr.tsr.factory.URCF;
import com.tidspr.tsr.io.FileIO;
import com.tidspr.tsr.response.AbnormalPrinter;
import com.tidspr.tsr.response.AbnormalPrinter.ResCode;
import com.tidspr.tsr.security.Authority;

public class FilePost extends HttpServlet
{
	private static final long serialVersionUID = 1L;

	@Override
    public void doPost(final HttpServletRequest req, final HttpServletResponse res)
    {
    	HttpSession session = req.getSession(true);
        String id = (String)session.getAttribute("id");
    	Authority auth = (id!=null&&!id.isEmpty()) ? Authority.authorized:Authority.notauthorized;
    	if(!auth.isAuthorized()){
    		AbnormalPrinter.Singleton.print(res, req, AbnormalPrinter.ResCode.Unauthorized);
    		return;
    	}
        
        String na = null;
        String wi = null;
        String co = null;
        Blob bl = null;
        try
        {
            final MultipartParser p = new MultipartParser(req, 10000000, false, false, "UTF-8");
            Part pa;
            while ((pa = p.readNextPart()) != null)
            {
                if (pa.isParam() && pa.getName().equals("wiki"))
                {
                	wi = URCF.decode(((ParamPart) pa).getStringValue());
                }
                else if (pa.isFile())
                {
                    final FilePart fp = ((FilePart) pa);
                    na = (fp.getFileName() == null) ? Long.toString(new Date().getTime()) + "." + fp.getContentType().substring(fp.getContentType().lastIndexOf('/') + 1) : fp.getFileName();
                    co = fp.getContentType();
                    bl = new Blob(IOUtils.toByteArray(fp.getInputStream()));
                }
            }
            if ((wi != null) && (bl != null)) FileIO.writeFile(na, bl, co, wi);
            else AbnormalPrinter.Singleton.print(res,req,ResCode.BadRequest);
        }
        catch (final IOException e1)
        {
            e1.printStackTrace();
        }
    }
}
