package com.tidspr.tsr;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.URL;

import javax.jdo.JDOObjectNotFoundException;
import javax.jdo.PersistenceManager;
import javax.servlet.ServletContext;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.tidspr.tsr.entity.Tidder;
import com.tidspr.tsr.io.AdminIO;
import com.tidspr.tsr.io.SiteIO;
import com.tidspr.tsr.io.TidderIO;

public class Initializer extends HttpServlet
{
	@Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
		if(AdminIO.readAdmin() != null) return;
		
        res.setContentType("text/html");
        res.setCharacterEncoding("UTF-8");
        
        try {
        	final StringBuilder msb = new StringBuilder();
        	try
            {
            	ServletContext context = getServletContext();
            	final URL u = context.getResource("/WEB-INF/initialform.txt");
                final BufferedReader in = new BufferedReader(new InputStreamReader(u.openStream(), "UTF-8"));
                String inputLine;
                while ((inputLine = in.readLine()) != null)
                {
                    msb.append(inputLine + "\n");
                }
                in.close();
            }
            catch (final IOException e1)
            {
                e1.printStackTrace();
            }
			final PrintWriter out = res.getWriter();
			out.write(msb.toString().trim());
		} catch (IOException e) {
			e.printStackTrace();
		}
    }
    
    @Override
    public void doPost(HttpServletRequest req, HttpServletResponse res) {
    	
    	if(AdminIO.readAdmin() != null) return;
    	
        String id = req.getParameter("id");
        String password = req.getParameter("password");
        String password2 = req.getParameter("password2");
        String sitename = req.getParameter("sitename");
        
        if(id == null || password == null || password2 == null || sitename == null || 
        		id.isEmpty() || password.isEmpty() || password2.isEmpty() || sitename.isEmpty() || !password.equals(password2)){
    		try {
				res.sendRedirect("/initializer");
			} catch (IOException e) {
				e.printStackTrace();
			}
        	return;
        }
        SiteIO.writeSite(sitename);
        AdminIO.writeAdmin(id, password);
        initialize();
        
    	HttpSession session = req.getSession(true);
    	session.invalidate();
    	HttpSession newSession = req.getSession(true);
    	newSession.setAttribute("id", id);
        new Wiki().wiki(req, res, sitename);
    }
    
    public void initialize(){
        prepare("StyleSheetLayout", "/WEB-INF/wiki.css", null);
        prepare("PageTemplate", "/WEB-INF/tmpl.txt", null);
        prepare("MailTemplate", "/WEB-INF/mailtmpl.txt", null);
        prepare("MainMenu", null, "[[Home|/]]\n[[PageTemplate]]\n[[MainMenu]]\n[[StyleSheetLayout]]");
    }
    
    private void prepare(String name, String fp, String dt){
    	Tidder _t = TidderIO.readTidder(name);
    	if(_t == null){
        	String raw = "";
            if(fp!=null){
            	final StringBuilder msb = new StringBuilder();
            	try
	            {
	            	ServletContext context = getServletContext();
	            	final URL u = context.getResource(fp);
	                final BufferedReader in = new BufferedReader(new InputStreamReader(u.openStream(), "UTF-8"));
	                String inputLine;
	                while ((inputLine = in.readLine()) != null)
	                {
	                    msb.append(inputLine + "\n");
	                }
	                in.close();
	            }
	            catch (final IOException e1)
	            {
	                e1.printStackTrace();
	            }
	            raw = msb.toString().trim();
            }else if(dt != null){
            	raw = dt;
            }
            TidderIO.writeTidder(name, raw);
    	}
    }
}
