package com.tidspr.tsr;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Properties;

import javax.jdo.JDOObjectNotFoundException;
import javax.jdo.PersistenceManager;
import javax.mail.*;
import javax.mail.internet.MimeMessage;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.google.appengine.api.datastore.Text;
import com.tidspr.tsr.entity.File;
import com.tidspr.tsr.entity.Mail;
import com.tidspr.tsr.factory.PMF;

public class MailContext extends HttpServlet{
  
	private static final long serialVersionUID = 1L;
	
    @Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
		String file = req.getParameter("file");
		if ((file == null) || (file.isEmpty())) return;
		
        final PersistenceManager pm = PMF.get().getPersistenceManager();
		Key k = KeyFactory.stringToKey(file);
		try {
			Mail m = (Mail) pm.getObjectById(Mail.class, k);
            res.setContentType("text/html");
            res.setCharacterEncoding("UTF-8");
            final PrintWriter out = res.getWriter();
            out.write("<pre style='white-space: -moz-pre-wrap;white-space: -pre-wrap;white-space: -o-pre-wrap;white-space: pre-wrap;word-wrap: break-word;margin:2em'>");
            out.write(encode(m.getText().getValue()));
            out.write("</pre>");
		} catch (JDOObjectNotFoundException localJDOObjectNotFoundException) {
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			pm.close();
		}
    }

    private String encode(final String str)
    {
        return str.replace("<", "&lt;").replace(">", "&gt;");
    }
}
