package com.tidspr.tsr;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.List;
import javax.jdo.PersistenceManager;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.appengine.api.datastore.KeyFactory;
import com.tidspr.tsr.entity.Mail;
import com.tidspr.tsr.entity.Tidder;
import com.tidspr.tsr.factory.PMF;
import com.tidspr.tsr.io.TidderIO;
import com.tidspr.tsr.toolbox.Miscellaneous;

public class MailList extends HttpServlet{
  
	private static final long serialVersionUID = 1L;

    @Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
    	Tidder _mpt = TidderIO.readTidder("MailTemplate");
    	if(_mpt == null) return;
    	
		String pageNumberStr = req.getParameter("page");
		int pageNumber = (pageNumberStr == null || !pageNumberStr.matches("[0-9]+"))? 0 : Integer.parseInt(pageNumberStr);
        final PersistenceManager pm = PMF.get().getPersistenceManager();
        final javax.jdo.Query que = pm.newQuery("SELECT FROM " + com.tidspr.tsr.entity.Mail.class.getName());
        que.setRange(0 + 50*pageNumber, 49 + 50*pageNumber);
        que.setOrdering("date descending");
        final List<Mail> list = (List<Mail>) que.execute();
        
        StringBuilder sb = new StringBuilder();
        for (final Mail m : list)
        {
        	String ks = KeyFactory.keyToString(m.key());
        	sb.append("<tr><td width='20em;'><a href='javascript:mailcontext(\""+ks+"\");' >"+m.getSubject()+"</a></td><td>" + Miscellaneous.INSTANCE.htmlEncode(m.getFrom().substring(0,m.getFrom().indexOf('@')))+"</td><td>"+new SimpleDateFormat("yyyy.MM.dd hh:mm").format(m.getDate()) + "</td></tr>");
        }
        
        try
        {
            res.setContentType("text/html");
            res.setCharacterEncoding("UTF-8");
			final PrintWriter out = res.getWriter();
			out.write(_mpt.html().replace("{{{mailtable}}}", sb.toString()).replace("{{{nextpage}}}", Integer.toString(pageNumber+1)));
        }
        catch (final IOException e)
        {
            e.printStackTrace();
        }
    }
}
