package com.tidspr.tsr;

import java.io.IOException;
import java.util.Date;
import java.util.Properties;

import javax.jdo.PersistenceManager;
import javax.mail.*;
import javax.mail.internet.MimeMessage;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.google.appengine.api.datastore.Text;
import com.tidspr.tsr.entity.Mail;
import com.tidspr.tsr.factory.PMF;

public class MailRR extends HttpServlet{
  
	private static final long serialVersionUID = 1L;

	@Override
    public void doPost(final HttpServletRequest req, final HttpServletResponse res)
    {
        final Properties props = new Properties();
        final Session session = Session.getDefaultInstance(props, null);
        try
        {
            MimeMessage message;
			message = new MimeMessage(session, req.getInputStream());
	        final String fr = message.getFrom()[0].toString();
	        final String to = message.getAllRecipients()[0].toString();
	        final String su = message.getSubject();
	        final Text tx = new Text((String) message.getContent());
	        final java.util.Date da = message.getSentDate();
	        final Mail m = new Mail(fr, to, da, su, tx);
	        final Key k = KeyFactory.createKey(Mail.class.getSimpleName(), Long.toString(new Date().getTime()));
	        m.key(k);
	        final PersistenceManager pm = PMF.get().getPersistenceManager();
	        pm.makePersistent(m);
	        pm.flush();
	        pm.close();
		
        }
        catch (final MessagingException e)
        {
            e.printStackTrace();
        }
        catch (IOException e) {
			e.printStackTrace();
		}
    }
}
