package com.tidspr.tsr;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;

import javax.jdo.JDOObjectNotFoundException;
import javax.jdo.PersistenceManager;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.tidspr.tsr.entity.Tidder;
import com.tidspr.tsr.factory.PMF;
import com.tidspr.tsr.io.TidderIO;
import com.tidspr.tsr.response.AbnormalPrinter;
import com.tidspr.tsr.response.AbnormalPrinter.ResCode;
import com.tidspr.tsr.url.URLHandler;
import com.tidspr.tsr.url.URLHandler.PC;

public class RawGet extends HttpServlet
{
    @Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
    	if(!URLHandler.INSTANCE.handle(req, res, PC.Raw)){
         	return;
        }
        raw(res, new File(req.getPathInfo()).getName(), req);
    }

    private void raw(final HttpServletResponse res, final String s, final HttpServletRequest req)
    {
    	Tidder _or = TidderIO.readTidder(s);
        if (_or == null || _or.raw() == null) //maybe _or exists then _or.raw == null won't likely happen though
        {
        	AbnormalPrinter.Singleton.print(res,req,ResCode.NotFound);
            return;
        }
        try
        {
        	String raw = _or.raw().getValue();
        	if(raw.startsWith("<!--{{{-->")){
        		res.setContentType("text/html");
        	}else if(raw.startsWith("/*{{{*/")){
        		res.setContentType("text/css");
        	}else{
        		res.setContentType("text/plain");        		
        	}
            res.setCharacterEncoding("UTF-8");
            final PrintWriter out = res.getWriter();
            out.write(raw);
        }
        catch (final IOException e)
        {
            e.printStackTrace();
        }
    }
}
