package com.tidspr.tsr;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

import javax.jdo.PersistenceManager;
import javax.jdo.Query;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.tidspr.tsr.entity.Tidder;
import com.tidspr.tsr.factory.PMF;
import com.tidspr.tsr.factory.URCF;
import com.tidspr.tsr.toolbox.Miscellaneous;

public class Search extends HttpServlet
{
    @SuppressWarnings("unchecked")
	@Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
		 final String keyword = req.getParameter("keyword");
		 if(keyword == null || keyword.isEmpty()) return;
		
    	 final PersistenceManager pm = PMF.get().getPersistenceManager();
         final String query = "select from " + Tidder.class.getName();
         final Query que = pm.newQuery(query);
         que.setOrdering("date descending");
         final List<Tidder> list = (List<Tidder>) que.execute();
         try
         {
             res.setContentType("text/html");
             res.setCharacterEncoding("UTF-8");
             final PrintWriter out = res.getWriter();
             out.write("<dl id='search_result'>\n");
             for (final Tidder t : list)
             {
            	 String raw = t.raw().getValue();
            	 String rawLow = raw.toLowerCase();
            	 String keywordLow = keyword.toLowerCase();
            	 if(t.name().toLowerCase().contains(keywordLow) || rawLow.contains(keywordLow))
            	 {
     	 			out.write("<dt><a href='"+URCF.encode(t.name())+"'>"+Miscellaneous.INSTANCE.htmlEncode(t.name()).replaceAll("(?i)"+keyword, "<span class='keyword'>$0</span>")+"</a></dt>\n");
     	 			int position = rawLow.indexOf(keywordLow);
     	 			String str = (position < 30)? raw : "..."+raw.substring(position-12);
     	 			String ret = (str.length() < 360)?Miscellaneous.INSTANCE.htmlEncode(str).replaceAll("(?i)"+keyword,"<span class='keyword'>$0</span>"):Miscellaneous.INSTANCE.htmlEncode(str.substring(0,360)).replaceAll("(?i)"+keyword,"<span class='keyword'>$0</span>")+"...";
     	 			out.write("<dd>"+ret+"</dd>\n");
            	 }
             }
             out.write("</dl>\n");
         }
         catch (final IOException e)
         {
             e.printStackTrace();
         }
    }    
}
