package com.tidspr.tsr.entity;

import java.util.Date;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.IdentityType;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.Text;

@PersistenceCapable(identityType = IdentityType.APPLICATION)
public class Mail
{

    public Date getDate()
    {
        return date;
    }

    public String getFrom()
    {
        return from;
    }

    public String getSubject()
    {
        return subject;
    }

    public Text getText()
    {
        return text;
    }

    public String getTo()
    {
        return to;
    }

    public Key key()
    {
        return key;
    }

    public void key(final Key key)
    {
        this.key = key;
    }

    public Mail(final String from, final String to, final Date date, final String subject, final Text text)
    {
        this.from = from;
        this.to = to;
        this.date = date;
        this.subject = subject;
        this.text = text;
    }

    @Persistent
    private Date date;

    @Persistent
    private String from;

    @PrimaryKey
    @Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
    private Key key;

    @Persistent
    private String subject;

    @Persistent
    private Text text;

    @Persistent
    private String to;

}