package com.tidspr.tsr.entity;

import java.util.Date;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.Text;
import com.tidspr.tsr.factory.TSRF;
import com.tidspr.tsr.factory.URCF;

@PersistenceCapable
public class Tidder
{
    public String html()
    {
        return html.getValue();
    }

    public Key key()
    {
        return key;
    }

    public void key(final Key key)
    {
        this.key = key;
    }

    public String name()
    {
        return name;
    }

    public Text raw()
    {
        return raw;
    }
    
    public Date date()
    {
        return date;
    }

    public void date(final Date date){
    	this.date = date;
    }
    
    public Tidder(final String name, final Text raw)
    {
        this.name = name;
        this.raw = raw;
        this.html = new Text(TSRF.get().parse(raw.getValue(),URCF.encode(name)));
        this.date = new Date();
    }

    public Tidder(final String name, final Text raw, final Date date)
    {
        this.name = name;
        this.raw = raw;
        this.html = new Text(TSRF.get().parse(raw.getValue(),URCF.encode(name)));
        this.date = date;
    }

    @Persistent
    private Text html;

    @PrimaryKey
    @Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
    private Key key;

    @Persistent
    private String name;

    @Persistent
    private Text raw;
    
    @Persistent
    private Date date;
}
