package com.tidspr.tsr.restore;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

import javax.jdo.PersistenceManager;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.codec.binary.Base64;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

import com.tidspr.tsr.entity.File;
import com.tidspr.tsr.factory.PMF;

public class ExportAttachments extends HttpServlet
{
	private static final long serialVersionUID = 1L;

	@SuppressWarnings("unchecked")
    @Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
        final String page = req.getParameter("p");
        final int p = (page == null) ? 0 : (!page.matches("[0-9]+")) ? 0 : Integer.parseInt(page);
        final PersistenceManager pm = PMF.get().getPersistenceManager();
        final javax.jdo.Query que = pm.newQuery("SELECT FROM " + File.class.getName());
        que.setRange(0 + (100 * p), 99 + (100 * p));
        System.out.println(que.toString());
        final List<File> list = (List<File>) que.execute();
        try
        {
            res.setContentType("application/json");
            res.setCharacterEncoding("UTF-8");
            final PrintWriter out = res.getWriter();
            final JSONArray rs = new JSONArray();
            for (final File f : list)
            {
                final JSONObject obj = new JSONObject();
                obj.put("name", f.name());
                obj.put("key", f.key().getName());
                obj.put("data", new String(Base64.encodeBase64(f.blob().getBytes())));
                obj.put("type", f.type());
                obj.put("wiki", f.wiki());
                rs.add(obj);
            }
            rs.writeJSONString(out);
        }
        catch (final IOException e)
        {
            e.printStackTrace();
        }
    }
}
