package com.tidspr.tsr.restore;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

import javax.jdo.PersistenceManager;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

import com.tidspr.tsr.entity.Tidder;
import com.tidspr.tsr.factory.PMF;

public class ExportTidders extends HttpServlet
{
	private static final long serialVersionUID = 1L;

	@SuppressWarnings("unchecked")
    @Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
        final String page = req.getParameter("p");
        final int p = (page == null) ? 0 : (!page.matches("[0-9]+")) ? 0 : Integer.parseInt(page);
        final PersistenceManager pm = PMF.get().getPersistenceManager();
        final javax.jdo.Query que = pm.newQuery("SELECT FROM " + Tidder.class.getName());
        que.setRange(0 + (100 * p), 99 + (100 * p));
        System.out.println(que.toString());
        final List<Tidder> list = (List<Tidder>) que.execute();
        try
        {
            res.setContentType("application/json");
            res.setCharacterEncoding("UTF-8");
            final PrintWriter out = res.getWriter();
            final JSONArray rs = new JSONArray();
            for (final Tidder t : list)
            {
                final JSONObject obj = new JSONObject();
                obj.put("name", t.name());
                obj.put("key", t.key().getName());
                obj.put("raw", t.raw().getValue());
                obj.put("date", Long.toString(t.date().getTime()));
                rs.add(obj);
            }
            rs.writeJSONString(out);
        }
        catch (final IOException e)
        {
            e.printStackTrace();
        }
    }
}
