package com.tidspr.tsr.restore;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.jdo.PersistenceManager;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.codec.binary.Base64;
import org.apache.commons.io.IOUtils;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.JSONValue;

import com.google.appengine.api.datastore.Blob;
import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.oreilly.servlet.multipart.FilePart;
import com.oreilly.servlet.multipart.MultipartParser;
import com.oreilly.servlet.multipart.Part;
import com.tidspr.tsr.entity.File;
import com.tidspr.tsr.factory.PMF;
import com.tidspr.tsr.response.AbnormalPrinter;
import com.tidspr.tsr.response.AbnormalPrinter.ResCode;
import com.tidspr.tsr.security.Authority;

public class ImportAttachments extends HttpServlet
{
	private static final long serialVersionUID = 1L;

	@Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
    	HttpSession session = req.getSession(true);
        String id = (String)session.getAttribute("id");
    	Authority auth = (id!=null&&!id.isEmpty()) ? Authority.authorized:Authority.notauthorized;
    	String enable = (auth.isAuthorized())?"":"disabled='true'";

        try
        {
            final PrintWriter out = res.getWriter();
            res.setContentType("text/html");
            res.setCharacterEncoding("UTF-8");
            out.write("<!DOCTYPE html><meta http-equiv='Content-Type' content='text/html; charset=utf-8' /><meta http-equiv='Content-Style-Type' content='text/css' /><meta http-equiv='Content-Script-Type' content='text/javascript' />");
            out.write("<head>");
            out.write("<title>Import Attachments</title>");
            out.write("<script src=\"/jquery-1.4.2.min.js\"></script>");
            out.write("<body style='text-align:center'>");
            out.write("<h1 style='padding-top:4em;'>choose json file [fs.export.json by default]<h1>");
            out.write("<div style='margin-top:1em;'><form accept-charset='utf-8' method='post' action='/fs.import.json' id='myform' enctype='multipart/form-data' ><input type='file' id='file' name='file' /><input type='submit' name='submit' value='submit' "+enable+" /></form></div>");
            out.write("</body>");
            out.write("</html>");
        }
        catch (final IOException e)
        {
            e.printStackTrace();
        }
    }

    @Override
    public void doPost(final HttpServletRequest req, final HttpServletResponse res)
    {
    	HttpSession session = req.getSession(true);
        String id = (String)session.getAttribute("id");
    	Authority auth = (id!=null&&!id.isEmpty()) ? Authority.authorized:Authority.notauthorized;
    	if(!auth.isAuthorized()){
    		AbnormalPrinter.Singleton.print(res, req, AbnormalPrinter.ResCode.Unauthorized);
    		return;
    	}

        try
        {
            final MultipartParser p = new MultipartParser(req, 50000000, false, false, "UTF-8");
            Part pa;
            while ((pa = p.readNextPart()) != null)
            {
                if (pa.isFile())
                {
                    final FilePart fp = ((FilePart) pa);
                    final List<File> ls = new LinkedList<File>();
                    final Object obj = JSONValue.parse(IOUtils.toString(fp.getInputStream(), "UTF-8"));
                    final JSONArray array = (JSONArray) obj;
                    if( array == null ){
                    	AbnormalPrinter.Singleton.print(res, req, ResCode.BadRequest);
                    	return;
                    }
                    final Iterator<Object> i = array.iterator();
                    while (i.hasNext())
                    {
                        final JSONObject jo = (JSONObject) i.next();
                        final File f = new File((String) jo.get("name"), new Blob(new Base64().decodeBase64((String) jo.get("data"))), (String) jo.get("type"), (String) jo.get("wiki"));
                        final Key k = KeyFactory.createKey(File.class.getSimpleName(), (String) jo.get("key"));
                        f.key(k);
                        ls.add(f);
                    }
                    final PersistenceManager pm = PMF.get().getPersistenceManager();
                    pm.makePersistentAll(ls);
                    pm.flush();
                    pm.close();
                    
                    try
                    {
                        res.setCharacterEncoding("UTF-8");
                        res.setContentType("text/html");
                        final PrintWriter writer = res.getWriter();
                        writer.write("import success");
                        return;
                    }
                    catch (final IOException e)
                    {
                        e.printStackTrace();
                    }
                }
            }
        }
        catch (final IOException e1)
        {
            try
            {
                res.setCharacterEncoding("UTF-8");
                res.setContentType("text/html");
                final PrintWriter writer = res.getWriter();
                writer.write(e1.getMessage());
                return;
            }
            catch (final IOException e)
            {
                e.printStackTrace();
            }
            e1.printStackTrace();
        }
    }
}
