package com.tidspr.tsr.security;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.URL;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.tidspr.tsr.entity.Admin;
import com.tidspr.tsr.factory.URCF;
import com.tidspr.tsr.io.AdminIO;


public class Login extends HttpServlet
{
	private static final long serialVersionUID = 1L;

	@Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
        res.setContentType("text/html");
        res.setCharacterEncoding("UTF-8");
    	HttpSession session = req.getSession(true);
        String id = (String)session.getAttribute("id");
    	if (id == null || id.isEmpty()) {
            try {
            	final StringBuilder msb = new StringBuilder();
            	try
	            {
	            	ServletContext context = getServletContext();
	            	final URL u = context.getResource("/WEB-INF/login.txt");
	                final BufferedReader in = new BufferedReader(new InputStreamReader(u.openStream(), "UTF-8"));
	                String inputLine;
	                while ((inputLine = in.readLine()) != null)
	                {
	                    msb.append(inputLine + "\n");
	                }
	                in.close();
	            }
	            catch (final IOException e1)
	            {
	                e1.printStackTrace();
	            }
    			final PrintWriter out = res.getWriter();
    			String url = req.getParameter("redirect");
    			out.write(((url == null) || (url.isEmpty()))? msb.toString().trim():msb.toString().trim().replace("<!--{{{redirect}}}-->", "<input type='hidden' name='redirect' value='"+URCF.encode(url)+"'>"));
    		} catch (IOException e) {
    			e.printStackTrace();
    		}
    	}else{
    		String url = req.getParameter("redirect");
    		if ((url == null) || (url.isEmpty())) {
                try {
        			final PrintWriter out = res.getWriter();
        			out.write("<html><head></head><body><div style='padding:20px;'><p>you are already logged in.</p><br/><br/><a href='/'>&nbsp;&nbsp;back to home</a></div></body></html>");
        		} catch (IOException e) {
        			e.printStackTrace();
        		}
        		return;
    		}
    		try {
				res.sendRedirect(url);
			} catch (IOException e) {
				e.printStackTrace();
			}
    	}
    }
    
    @Override
    public void doPost(HttpServletRequest req, HttpServletResponse res) {
        
        String id = req.getParameter("id");
        String password = req.getParameter("password");
        String url = req.getParameter("redirect");
        
        if(id == null || password == null || id.isEmpty() || password.isEmpty()){
        	try {
        		if ((url == null) || (url.isEmpty())) res.sendRedirect("/login");
        		else res.sendRedirect("/login?redirect="+url);
    		} catch (IOException e) {
    				e.printStackTrace();
    		}
    		return;
        }
        
        Admin _admin = AdminIO.readAdmin();
        if (_admin.id().equals(id) && _admin.password().equals(password)) {

        	HttpSession session = req.getSession(true);
     
        	session.invalidate();
        	HttpSession newSession = req.getSession(true);
        	newSession.setAttribute("id", id);
          
        	try {
	    		if ((url == null) || (url.isEmpty())) res.sendRedirect("/");
	    		else res.sendRedirect(url);
        	} catch (IOException e) {
					e.printStackTrace();
        	}
        	return;
        } 
        
    	try {
    		if ((url == null) || (url.isEmpty())) res.sendRedirect("/login");
    		else res.sendRedirect("/login?redirect="+url);
		} catch (IOException e) {
				e.printStackTrace();
		}
    }
}
